import React, { Component } from 'react';

import Label from './Label';
import Indexes from './Indexes';
import Hand from './Hand';

class Grid extends Component {
    render() {
        var styles = this.props.styles;

        var gridNodes = [];
        var gridCount = 9;

        for(var i=0; i < gridCount; i++){
            var gridNodeNumber = i + 1;
            var gridNodeClasses = {
                dBlock : 'd-block',
                mxAuto : 'mx-auto',
                shape : '',
                bg : ''
            };

            var gridNodeStyles = {
                width : '100%',
                height : '100%',
                position : 'relative',
                border : ''
            };

            var customGrid = styles[gridNodeNumber];
            
            if (customGrid && typeof customGrid.dial !== 'undefined') {
                var dialStyles = customGrid.dial;
                
                var border = dialStyles.border;
                gridNodeStyles.border = border;

                var bg = dialStyles.bg;
                gridNodeClasses.bg = bg;
                var shape = dialStyles.shape;
                gridNodeClasses.shape = shape;
            }
            
            gridNodeClasses = Object.values(gridNodeClasses);
            gridNodeClasses = gridNodeClasses.join(' ');

            var hand;
            if (customGrid && typeof customGrid.hand !== 'undefined') {
                var handStyles = customGrid.hand;                
                hand = (
                    <Hand
                        styles={handStyles}
                        type={handStyles.type}
                    />
                )
            } else {
                hand = null;
            }

            var indexes;
            if (customGrid && typeof customGrid.index !== 'undefined') {
                var indexStyles = customGrid.index;
                indexes = <Indexes key={gridNodeNumber} styles={indexStyles} />;
            } else {
                indexes = null;
            }

            var label;
            if (customGrid && typeof customGrid.label !== 'undefined') {
                var labelStyles = customGrid.label;
                label = <Label key={gridNodeNumber} styles={labelStyles} />;
            } else {
                label = null;
            }            

            var gridNode = (
                <div
                    key={gridNodeNumber}
                    className="col-4"
                    style={{
                        height : 'calc(100%/3)'
                    }} >
                    <div
                        className={gridNodeClasses}
                        style={gridNodeStyles} >
                        {hand}
                        {indexes}
                        {label}
                    </div>
                </div>
            );

            gridNodes.push(gridNode);
        }

        return (
            <div
                className="row no-gutters"
                style={{
                    width : '100%',
                    height : '100%'
                }}>
                {gridNodes}
            </div>
        );
    }
};

export default Grid