import React, { Component } from 'react';

class Burst extends Component {
    constructor(props) {
        super(props);

        this.state = {
            burstStyles: { }
        }
    }

    componentDidMount() {
        var dial = this.dial
            , dialDiameter = dial.clientWidth
            , dialRadius = dialDiameter / 2;

        this.setState({
            burstStyles: {
                borderLeftWidth: dialRadius,
                borderRightWidth: dialRadius,
                borderBottomWidth: dialDiameter
            }
        });

        window.addEventListener("resize", this.setBurst.bind(this));
    }

    setBurst() {
        var dial = this.dial
            , dialDiameter = dial.clientWidth
            , dialRadius = dialDiameter / 2;

        this.setState({
            burstStyles: {
                borderLeftWidth: dialRadius,
                borderRightWidth: dialRadius,
                borderBottomWidth: dialDiameter
            }
        });
    }

    render() {
        var burstStyles = this.state.burstStyles;

        var standardStyles = {
            content: '',
            position: 'absolute',
            width: '0',
            height: '0',
            display: 'block',
            borderStyle: 'solid',
            borderLeftColor: 'transparent',
            borderRightColor: 'transparent',
            borderBottomColor: 'rgba(0, 0, 0, 0.05)',
            borderTopWidth: '0'
        };

        return (
            <div ref={(dial) => { this.dial = dial; }}
                    style={{
                        height: '100%',
                        width: '100%',
                        boxSizing: 'border-box',
                        position: 'absolute',
                        top: 0,
                        left: 0,
                        transform: 'rotate(45deg)'
                    }}>
                 <span className="burst" style={Object.assign({}, burstStyles, standardStyles, {transform: 'rotate(0)', top: '50%', left: '0'})}></span>
                 <span className="burst" style={Object.assign({}, burstStyles, standardStyles, {transform: 'rotate(90deg)', top: '0', left: '-50%'})}></span>
                 <span className="burst" style={Object.assign({}, burstStyles, standardStyles, {transform: 'rotate(180deg)', top: '-50%', left: '0'})}></span>
                 <span className="burst" style={Object.assign({}, burstStyles, standardStyles, {transform: 'rotate(270deg)', top: '0', left: '50%'})}></span>
            </div>
        )
    }
};

export default Burst